#ifndef _oswald_hal_h
#define _oswald_hal_h

/*
 * these functions must be implemented for a concrete hardware
 */

const char *hal_get_version_string(void);
const char *hal_get_buildno_string(void);
const char *hal_get_radio_version_string(void);

void hal_lcd_set_pixel(uint8_t x, uint8_t y, uint8_t color);
void hal_lcd_clear_display(void);
void hal_lcd_update_display(void);
/* sets the backlight on/off, on=TRUE, off=FALSE */
void hal_lcd_set_backlight(boolean state);
boolean hal_lcd_get_backlight(void);

void hal_enable_centisecond_timer(void);
void hal_disable_centisecond_timer(void);

void hal_enable_halfsecond_timer(void);
void hal_disable_halfsecond_timer(void);

void hal_get_rtc(clock_state *rtc);
void hal_set_rtc(clock_state *rtc, boolean set_set);
void hal_get_power_state(power_state *pwr);

/* sets the vibration motor on/off, on=TRUE, off=FALSE */
void hal_vibration_set_state(boolean state);
boolean hal_vibration_get_state(void);

bluetooth_state hal_bluetooth_set_state(bluetooth_state state);
bluetooth_state hal_bluetooth_get_state(void);
uint8_t *hal_bluetooth_get_local_bdaddr(void);
void hal_bluetooth_set_visible(boolean visible);
boolean hal_bluetooth_get_visible(void);
void hal_bluetooth_send_data(const void *mdat, uint16_t mlen);

void hal_accelerometer_enable(void);
void hal_accelerometer_disable(void);

uint16_t hal_amblight_get_val(void);

#endif
